Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 4494)
+++ palm/trunk/SOURCE/Makefile	(revision 4495)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# added routines and dependencies for restart data with MPI-IO
+# 
+# 4493 2020-04-10 09:49:43Z pavelkrc
 # cpu measures in advec_ws added
 #
@@ -255,4 +258,5 @@
 	poismg_noopt_mod.f90 \
 	posix_calls_from_fortran.f90 \
+	posix_interface_mod.f90 \
 	pres.f90 \
 	print_1d.f90 \
@@ -264,4 +268,5 @@
 	random_generator_parallel_mod.f90 \
 	read_restart_data_mod.f90 \
+	restart_data_mpi_io_mod.f90 \
 	run_control.f90 \
 	salsa_mod.f90 \
@@ -385,5 +390,6 @@
 	netcdf_data_input_mod.o \
 	palm_date_time_mod.o \
-	radiation_model_mod.o
+	radiation_model_mod.o \
+	restart_data_mpi_io_mod.o
 bulk_cloud_model_mod.o: \
 	basic_constants_and_equations_mod.o \
@@ -397,4 +403,5 @@
 	mod_kinds.o \
 	modules.o \
+	restart_data_mpi_io_mod.o \
 	surface_mod.o
 buoyancy.o: \
@@ -596,6 +603,6 @@
 	basic_constants_and_equations_mod.o \
 	mod_kinds.o \
-        surface_mod.o \
-        pmc_interface_mod.o \
+	surface_mod.o \
+	pmc_interface_mod.o \
 	modules.o
 exchange_horiz_mod.o: \
@@ -735,4 +742,5 @@
 	random_function_mod.o \
 	random_generator_parallel_mod.o \
+	restart_data_mpi_io_mod.o \
 	surface_mod.o
 land_surface_model_mod.o: \
@@ -866,4 +874,5 @@
 	modules.o \
 	pmc_interface_mod.o \
+	restart_data_mpi_io_mod.o \
 	surface_mod.o
 outflow_turbulence.o: \
@@ -885,4 +894,5 @@
 	pmc_interface_mod.o \
 	pmc_particle_interface.o \
+	restart_data_mpi_io_mod.o \
 	salsa_mod.o \
 	surface_layer_fluxes_mod.o \
@@ -912,4 +922,5 @@
 	modules.o \
 	netcdf_data_input_mod.o \
+	restart_data_mpi_io_mod.o \
 	surface_mod.o
 pmc_particle_interface.o: \
@@ -969,4 +980,6 @@
 posix_calls_from_fortran.o: \
 
+posix_interface_mod.o: \
+	mod_kinds.o
 pres.o: \
 	cpulog_mod.o \
@@ -1029,4 +1042,5 @@
 	palm_date_time_mod.o \
 	plant_canopy_model_mod.o \
+	restart_data_mpi_io_mod.o \
 	surface_mod.o
 random_function_mod.o: \
@@ -1038,13 +1052,17 @@
 random_generator_parallel_mod.o: \
 	mod_kinds.o \
-	modules.o
+	modules.o \
+	posix_interface_mod.o
 read_restart_data_mod.o: \
+	bulk_cloud_model_mod.o \
 	chem_modules.o \
 	cpulog_mod.o \
 	diagnostic_output_quantities_mod.o \
+	gust_mod.o \
 	mod_kinds.o \
 	model_1d_mod.o \
 	module_interface.o \
 	modules.o \
+	mod_particle_attributes.o \
 	netcdf_interface_mod.o \
 	palm_date_time_mod.o \
@@ -1052,8 +1070,15 @@
 	random_function_mod.o\
 	random_generator_parallel_mod.o \
+	restart_data_mpi_io_mod.o \
 	spectra_mod.o \
 	surface_mod.o \
+	user_module.o \
 	vertical_nesting_mod.o \
 	virtual_measurement_mod.o
+restart_data_mpi_io_mod.o: \
+	modules.o \
+	mod_kinds.o \
+	exchange_horiz_mod.o \
+	posix_interface_mod.o
 run_control.o: \
 	cpulog_mod.o \
@@ -1121,5 +1146,6 @@
 	model_1d_mod.o \
 	mod_kinds.o \
-	modules.o
+	modules.o \
+	restart_data_mpi_io_mod.o
 surface_data_output_mod.o: \
 	mod_kinds.o \
@@ -1127,4 +1153,5 @@
 	netcdf_data_input_mod.o \
 	netcdf_interface_mod.o \
+	restart_data_mpi_io_mod.o \
 	surface_mod.o
 synthetic_turbulence_generator_mod.o: \
@@ -1137,4 +1164,5 @@
 	pmc_interface_mod.o \
 	random_generator_parallel_mod.o \
+	restart_data_mpi_io_mod.o \
 	surface_mod.o
 temperton_fft_mod.o: \
@@ -1242,4 +1270,5 @@
 	palm_date_time_mod.o \
 	radiation_model_mod.o \
+	restart_data_mpi_io_mod.o \
 	surface_mod.o
 user_data_output_mask.o: \
@@ -1320,4 +1349,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
+	restart_data_mpi_io_mod.o \
 	user_flight.o \
 	user_init_flight.o
@@ -1342,12 +1372,16 @@
 	netcdf_data_input_mod.o \
 	mod_kinds.o \
-	modules.o
+	modules.o \
+	restart_data_mpi_io_mod.o
 wrd_write_string.o: \
 	mod_kinds.o
 write_restart_data_mod.o: \
+	bulk_cloud_model_mod.o \
+	gust_mod.o \
 	mod_kinds.o \
 	model_1d_mod.o \
 	module_interface.o \
 	modules.o \
+	mod_particle_attributes.o \
 	netcdf_interface_mod.o \
 	palm_date_time_mod.o \
@@ -1355,6 +1389,8 @@
 	random_function_mod.o \
 	random_generator_parallel_mod.o \
+	restart_data_mpi_io_mod.o \
 	spectra_mod.o \
 	surface_mod.o \
+	user_module.o \
 	vertical_nesting_mod.o \
 	virtual_measurement_mod.o
Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4495)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4493 2020-04-10 09:49:43Z pavelkrc
 ! Revise bad formatting
 ! 
@@ -144,5 +147,5 @@
                dz, dz_stretch_factor,                                          &
                dz_stretch_level, humidity, initializing_actions, nz_do3d,      &
-               surface_pressure
+               restart_data_format_output, surface_pressure
 
     USE grid_variables,                                                        &
@@ -168,4 +171,8 @@
                radiation_interactions, rad_sw_in,                              &
                rad_sw_out, rad_lw_in, rad_lw_out
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rrd_mpi_io, wrd_mpi_io
+
 
     IMPLICIT NONE
@@ -352,5 +359,6 @@
 !-- Read global restart parameters
     INTERFACE bio_rrd_global
-       MODULE PROCEDURE bio_rrd_global
+       MODULE PROCEDURE bio_rrd_global_ftn
+       MODULE PROCEDURE bio_rrd_global_mpi
     END INTERFACE bio_rrd_global
 !
@@ -1330,7 +1338,7 @@
 ! Description:
 ! ------------
-!> Soubroutine reads global biometeorology configuration from restart file(s)
-!------------------------------------------------------------------------------!
- SUBROUTINE bio_rrd_global( found )
+!> Read module-specific global restart data (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE bio_rrd_global_ftn( found )
 
     USE control_parameters,                                                    &
@@ -1389,5 +1397,31 @@
 
 
- END SUBROUTINE bio_rrd_global
+ END SUBROUTINE bio_rrd_global_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE bio_rrd_global_mpi
+
+
+!
+!--  Read control flags to determine if input grids need to be averaged
+     CALL rrd_mpi_io( 'do_average_theta', do_average_theta )
+     CALL rrd_mpi_io( 'do_average_q', do_average_q )
+     CALL rrd_mpi_io( 'do_average_u', do_average_u )
+     CALL rrd_mpi_io( 'do_average_v', do_average_v )
+     CALL rrd_mpi_io( 'do_average_w', do_average_w )
+     CALL rrd_mpi_io( 'do_average_mrt', do_average_mrt )
+!
+!--  Rad control flags to determine which thermal index needs to trigger averaging
+     CALL rrd_mpi_io( 'average_trigger_perct', average_trigger_perct )
+     CALL rrd_mpi_io( 'average_trigger_utci', average_trigger_utci )
+     CALL rrd_mpi_io( 'average_trigger_pet', average_trigger_pet )
+     CALL rrd_mpi_io( 'average_trigger_mrt', average_trigger_mrt )
+
+ END SUBROUTINE bio_rrd_global_mpi
 
 
@@ -1442,24 +1476,40 @@
     IMPLICIT NONE
 
-    CALL wrd_write_string( 'do_average_theta' )
-    WRITE ( 14 )  do_average_theta
-    CALL wrd_write_string( 'do_average_q' )
-    WRITE ( 14 )  do_average_q
-    CALL wrd_write_string( 'do_average_u' )
-    WRITE ( 14 )  do_average_u
-    CALL wrd_write_string( 'do_average_v' )
-    WRITE ( 14 )  do_average_v
-    CALL wrd_write_string( 'do_average_w' )
-    WRITE ( 14 )  do_average_w
-    CALL wrd_write_string( 'do_average_mrt' )
-    WRITE ( 14 )  do_average_mrt
-    CALL wrd_write_string( 'average_trigger_perct' )
-    WRITE ( 14 )  average_trigger_perct
-    CALL wrd_write_string( 'average_trigger_utci' )
-    WRITE ( 14 )  average_trigger_utci
-    CALL wrd_write_string( 'average_trigger_pet' )
-    WRITE ( 14 )  average_trigger_pet
-    CALL wrd_write_string( 'average_trigger_mrt' )
-    WRITE ( 14 )  average_trigger_mrt
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+       CALL wrd_write_string( 'do_average_theta' )
+       WRITE ( 14 )  do_average_theta
+       CALL wrd_write_string( 'do_average_q' )
+       WRITE ( 14 )  do_average_q
+       CALL wrd_write_string( 'do_average_u' )
+       WRITE ( 14 )  do_average_u
+       CALL wrd_write_string( 'do_average_v' )
+       WRITE ( 14 )  do_average_v
+       CALL wrd_write_string( 'do_average_w' )
+       WRITE ( 14 )  do_average_w
+       CALL wrd_write_string( 'do_average_mrt' )
+       WRITE ( 14 )  do_average_mrt
+       CALL wrd_write_string( 'average_trigger_perct' )
+       WRITE ( 14 )  average_trigger_perct
+       CALL wrd_write_string( 'average_trigger_utci' )
+       WRITE ( 14 )  average_trigger_utci
+       CALL wrd_write_string( 'average_trigger_pet' )
+       WRITE ( 14 )  average_trigger_pet
+       CALL wrd_write_string( 'average_trigger_mrt' )
+       WRITE ( 14 )  average_trigger_mrt
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+       CALL wrd_mpi_io( 'do_average_theta', do_average_theta )
+       CALL wrd_mpi_io( 'do_average_q', do_average_q )
+       CALL wrd_mpi_io( 'do_average_u', do_average_u )
+       CALL wrd_mpi_io( 'do_average_v', do_average_v )
+       CALL wrd_mpi_io( 'do_average_w', do_average_w )
+       CALL wrd_mpi_io( 'do_average_mrt', do_average_mrt )
+       CALL wrd_mpi_io( 'average_trigger_perct', average_trigger_perct )
+       CALL wrd_mpi_io( 'average_trigger_utci', average_trigger_utci )
+       CALL wrd_mpi_io( 'average_trigger_pet', average_trigger_pet )
+       CALL wrd_mpi_io( 'average_trigger_mrt', average_trigger_mrt )
+    ENDIF
 
  END SUBROUTINE bio_wrd_global
@@ -1475,14 +1525,29 @@
     IMPLICIT NONE
 
-!
-!-- First nmrtbl has to be written/read, because it is the dimension of mrt_av_grid
-    CALL wrd_write_string( 'nmrtbl' )
-    WRITE ( 14 )  nmrtbl
-
-    IF ( ALLOCATED( mrt_av_grid ) )  THEN
-       CALL wrd_write_string( 'mrt_av_grid' )
-       WRITE ( 14 )  mrt_av_grid
-    ENDIF
-
+
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+!
+!--    First nmrtbl has to be written/read, because it is the dimension of mrt_av_grid
+       CALL wrd_write_string( 'nmrtbl' )
+       WRITE ( 14 )  nmrtbl
+
+       IF ( ALLOCATED( mrt_av_grid ) )  THEN
+          CALL wrd_write_string( 'mrt_av_grid' )
+          WRITE ( 14 )  mrt_av_grid
+       ENDIF
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+!
+!--   TODO: the mrt_av_grid is a 1-d array and its size depends on subdomain features. This does
+!--         not work with the MPI-IO concept (nor with the restart I/O concept in general.
+!--         I am not sure, if this data needs to be written to the restart file at all (Siggi, 13.4.20)
+!       CALL wrd_mpi_io( 'nmrtbl', nmrtbl )
+!       CALL wrd_mpi_io_..... 'mrt_av_grid'
+       WRITE (6,*) '+++ biometeorology module does not work with MPI-IO for restart_data'
+       STOP
+
+    ENDIF
 
  END SUBROUTINE bio_wrd_local
Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4457 2020-03-11 14:20:43Z raasch
 ! use statement for exchange horiz added
 ! 
@@ -140,5 +143,5 @@
                dt_3d, dt_do2d_xy, intermediate_timestep_count,                 &
                intermediate_timestep_count_max, large_scale_forcing,           &
-               lsf_surf, pt_surface, rho_surface, surface_pressure,            &
+               lsf_surf, pt_surface, restart_data_format_output, rho_surface, surface_pressure,   &
                time_do2d_xy, message_string, initializing_actions,             &
                ws_scheme_sca, scalar_advec, timestep_scheme, tsc, loop_optimization
@@ -163,4 +166,7 @@
     USE pegrid,                                                                &
         ONLY:  threads_per_task
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rrd_mpi_io, wrd_mpi_io
 
     USE statistics,                                                            &
@@ -365,5 +371,6 @@
 
     INTERFACE bcm_rrd_global
-       MODULE PROCEDURE bcm_rrd_global
+       MODULE PROCEDURE bcm_rrd_global_ftn
+       MODULE PROCEDURE bcm_rrd_global_mpi
     END INTERFACE bcm_rrd_global
 
@@ -2684,7 +2691,7 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data for the bulk cloud module.
-!------------------------------------------------------------------------------!
-    SUBROUTINE bcm_rrd_global( found )
+!> Read module-specific global restart data (Fortran binary format).
+!------------------------------------------------------------------------------!
+    SUBROUTINE bcm_rrd_global_ftn( found )
 
 
@@ -2744,11 +2751,4 @@
              READ ( 13 )  curvature_solution_effects_bulk
 
-
-!          CASE ( 'global_paramter' )
-!             READ ( 13 )  global_parameter
-!          CASE ( 'global_array' )
-!             IF ( .NOT. ALLOCATED( global_array ) )  ALLOCATE( global_array(1:10) )
-!             READ ( 13 )  global_array
-
           CASE DEFAULT
 
@@ -2758,5 +2758,30 @@
 
 
-    END SUBROUTINE bcm_rrd_global
+    END SUBROUTINE bcm_rrd_global_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!------------------------------------------------------------------------------!
+    SUBROUTINE bcm_rrd_global_mpi
+
+       CALL rrd_mpi_io( 'c_sedimentation', c_sedimentation )
+       CALL rrd_mpi_io( 'bulk_cloud_model', bulk_cloud_model )
+       CALL rrd_mpi_io( 'cloud_scheme', cloud_scheme )
+       CALL rrd_mpi_io( 'cloud_water_sedimentation', cloud_water_sedimentation )
+       CALL rrd_mpi_io( 'collision_turbulence', collision_turbulence )
+       CALL rrd_mpi_io( 'limiter_sedimentation', limiter_sedimentation )
+       CALL rrd_mpi_io( 'nc_const', nc_const )
+       CALL rrd_mpi_io( 'precipitation', precipitation )
+       CALL rrd_mpi_io( 'ventilation_effect', ventilation_effect )
+       CALL rrd_mpi_io( 'na_init', na_init )
+       CALL rrd_mpi_io( 'dry_aerosol_radius', dry_aerosol_radius )
+       CALL rrd_mpi_io( 'sigma_bulk', sigma_bulk )
+       CALL rrd_mpi_io( 'aerosol_bulk', aerosol_bulk )
+       CALL rrd_mpi_io( 'curvature_solution_effects_bulk', curvature_solution_effects_bulk )
+
+    END SUBROUTINE bcm_rrd_global_mpi
 
 
@@ -2915,56 +2940,67 @@
        IMPLICIT NONE
 
-       CALL wrd_write_string( 'c_sedimentation' )
-       WRITE ( 14 )  c_sedimentation
-
-       CALL wrd_write_string( 'bulk_cloud_model' )
-       WRITE ( 14 )  bulk_cloud_model
-
-       CALL wrd_write_string( 'cloud_scheme' )
-       WRITE ( 14 )  cloud_scheme
-
-       CALL wrd_write_string( 'cloud_water_sedimentation' )
-       WRITE ( 14 )  cloud_water_sedimentation
-
-       CALL wrd_write_string( 'collision_turbulence' )
-       WRITE ( 14 )  collision_turbulence
-
-       CALL wrd_write_string( 'limiter_sedimentation' )
-       WRITE ( 14 )  limiter_sedimentation
-
-       CALL wrd_write_string( 'nc_const' )
-       WRITE ( 14 )  nc_const
-
-       CALL wrd_write_string( 'precipitation' )
-       WRITE ( 14 )  precipitation
-
-       CALL wrd_write_string( 'ventilation_effect' )
-       WRITE ( 14 )  ventilation_effect
-
-       CALL wrd_write_string( 'na_init' )
-       WRITE ( 14 )  na_init
-
-       CALL wrd_write_string( 'dry_aerosol_radius' )
-       WRITE ( 14 )  dry_aerosol_radius
-
-       CALL wrd_write_string( 'sigma_bulk' )
-       WRITE ( 14 )  sigma_bulk
-
-       CALL wrd_write_string( 'aerosol_bulk' )
-       WRITE ( 14 )  aerosol_bulk
-
-       CALL wrd_write_string( 'curvature_solution_effects_bulk' )
-       WRITE ( 14 )  curvature_solution_effects_bulk
-
-
-! needs preceeding allocation if array
-!       CALL wrd_write_string( 'global_parameter' )
-!       WRITE ( 14 )  global_parameter
-
-!       IF ( ALLOCATED( inflow_damping_factor ) )  THEN
-!          CALL wrd_write_string( 'inflow_damping_factor' )
-!          WRITE ( 14 )  inflow_damping_factor
-!       ENDIF
-
+
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+          CALL wrd_write_string( 'c_sedimentation' )
+          WRITE ( 14 )  c_sedimentation
+
+          CALL wrd_write_string( 'bulk_cloud_model' )
+          WRITE ( 14 )  bulk_cloud_model
+
+          CALL wrd_write_string( 'cloud_scheme' )
+          WRITE ( 14 )  cloud_scheme
+
+          CALL wrd_write_string( 'cloud_water_sedimentation' )
+          WRITE ( 14 )  cloud_water_sedimentation
+
+          CALL wrd_write_string( 'collision_turbulence' )
+          WRITE ( 14 )  collision_turbulence
+
+          CALL wrd_write_string( 'limiter_sedimentation' )
+          WRITE ( 14 )  limiter_sedimentation
+
+          CALL wrd_write_string( 'nc_const' )
+          WRITE ( 14 )  nc_const
+
+          CALL wrd_write_string( 'precipitation' )
+          WRITE ( 14 )  precipitation
+
+          CALL wrd_write_string( 'ventilation_effect' )
+          WRITE ( 14 )  ventilation_effect
+
+          CALL wrd_write_string( 'na_init' )
+          WRITE ( 14 )  na_init
+
+          CALL wrd_write_string( 'dry_aerosol_radius' )
+          WRITE ( 14 )  dry_aerosol_radius
+
+          CALL wrd_write_string( 'sigma_bulk' )
+          WRITE ( 14 )  sigma_bulk
+
+          CALL wrd_write_string( 'aerosol_bulk' )
+          WRITE ( 14 )  aerosol_bulk
+
+          CALL wrd_write_string( 'curvature_solution_effects_bulk' )
+          WRITE ( 14 )  curvature_solution_effects_bulk
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+          CALL wrd_mpi_io( 'c_sedimentation', c_sedimentation )
+          CALL wrd_mpi_io( 'bulk_cloud_model', bulk_cloud_model )
+          CALL wrd_mpi_io( 'cloud_scheme', cloud_scheme )
+          CALL wrd_mpi_io( 'cloud_water_sedimentation', cloud_water_sedimentation )
+          CALL wrd_mpi_io( 'collision_turbulence', collision_turbulence )
+          CALL wrd_mpi_io( 'limiter_sedimentation', limiter_sedimentation )
+          CALL wrd_mpi_io( 'nc_const', nc_const )
+          CALL wrd_mpi_io( 'precipitation', precipitation )
+          CALL wrd_mpi_io( 'ventilation_effect', ventilation_effect )
+          CALL wrd_mpi_io( 'na_init', na_init )
+          CALL wrd_mpi_io( 'dry_aerosol_radius', dry_aerosol_radius )
+          CALL wrd_mpi_io( 'sigma_bulk', sigma_bulk )
+          CALL wrd_mpi_io( 'aerosol_bulk', aerosol_bulk )
+          CALL wrd_mpi_io( 'curvature_solution_effects_bulk', curvature_solution_effects_bulk )
+
+       ENDIF
 
     END SUBROUTINE bcm_wrd_global
@@ -2981,67 +3017,93 @@
        IMPLICIT NONE
 
-       IF ( ALLOCATED( prr ) )  THEN
-          CALL wrd_write_string( 'prr' )
-          WRITE ( 14 )  prr
+
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+          IF ( ALLOCATED( prr ) )  THEN
+             CALL wrd_write_string( 'prr' )
+             WRITE ( 14 )  prr
+          ENDIF
+
+          IF ( ALLOCATED( prr_av ) )  THEN
+             CALL wrd_write_string( 'prr_av' )
+             WRITE ( 14 )  prr_av
+          ENDIF
+
+          IF ( ALLOCATED( precipitation_amount ) )  THEN
+             CALL wrd_write_string( 'precipitation_amount' )
+             WRITE ( 14 )  precipitation_amount
+          ENDIF
+
+          CALL wrd_write_string( 'ql' )
+          WRITE ( 14 )  ql
+
+          IF ( ALLOCATED( ql_av ) )  THEN
+             CALL wrd_write_string( 'ql_av' )
+             WRITE ( 14 )  ql_av
+          ENDIF
+
+          CALL wrd_write_string( 'qc' )
+          WRITE ( 14 )  qc
+
+          IF ( ALLOCATED( qc_av ) )  THEN
+             CALL wrd_write_string( 'qc_av' )
+             WRITE ( 14 )  qc_av
+          ENDIF
+
+          IF ( microphysics_morrison )  THEN
+
+             CALL wrd_write_string( 'nc' )
+             WRITE ( 14 )  nc
+
+             IF ( ALLOCATED( nc_av ) )  THEN
+                CALL wrd_write_string( 'nc_av' )
+                WRITE ( 14 )  nc_av
+             ENDIF
+
+          ENDIF
+
+          IF ( microphysics_seifert )  THEN
+
+             CALL wrd_write_string( 'nr' )
+             WRITE ( 14 )  nr
+
+             IF ( ALLOCATED( nr_av ) )  THEN
+                CALL wrd_write_string( 'nr_av' )
+                WRITE ( 14 )  nr_av
+             ENDIF
+
+             CALL wrd_write_string( 'qr' )
+             WRITE ( 14 )  qr
+
+             IF ( ALLOCATED( qr_av ) )  THEN
+                CALL wrd_write_string( 'qr_av' )
+                WRITE ( 14 )  qr_av
+             ENDIF
+
+          ENDIF
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+          IF ( ALLOCATED( prr ) )  CALL wrd_mpi_io( 'prr', prr )
+          IF ( ALLOCATED( prr_av ) )  CALL wrd_mpi_io( 'prr_av', prr_av )
+          IF ( ALLOCATED( precipitation_amount ) )  THEN
+             CALL wrd_mpi_io( 'precipitation_amount', precipitation_amount )
+          ENDIF
+          CALL wrd_mpi_io( 'ql', ql )
+          IF ( ALLOCATED( ql_av ) )  CALL wrd_mpi_io( 'ql_av', ql_av )
+          CALL wrd_mpi_io( 'qc', qc )
+          IF ( ALLOCATED( qc_av ) )  CALL wrd_mpi_io( 'qc_av', qc_av )
+          IF ( microphysics_morrison )  THEN
+             CALL wrd_mpi_io( 'nc', nc )
+             IF ( ALLOCATED( nc_av ) )  CALL wrd_mpi_io( 'nc_av', nc_av )
+          ENDIF
+          IF ( microphysics_seifert )  THEN
+             CALL wrd_mpi_io( 'nr', nr )
+             IF ( ALLOCATED( nr_av ) )  CALL wrd_mpi_io( 'nr_av', nr_av )
+             CALL wrd_mpi_io( 'qr', qr )
+             IF ( ALLOCATED( qr_av ) )  CALL wrd_mpi_io( 'qr_av', qr_av )
+          ENDIF
+
        ENDIF
-
-       IF ( ALLOCATED( prr_av ) )  THEN
-          CALL wrd_write_string( 'prr_av' )
-          WRITE ( 14 )  prr_av
-       ENDIF
-
-       IF ( ALLOCATED( precipitation_amount ) )  THEN
-          CALL wrd_write_string( 'precipitation_amount' )
-          WRITE ( 14 )  precipitation_amount
-       ENDIF
-
-       CALL wrd_write_string( 'ql' )
-       WRITE ( 14 )  ql
-
-       IF ( ALLOCATED( ql_av ) )  THEN
-          CALL wrd_write_string( 'ql_av' )
-          WRITE ( 14 )  ql_av
-       ENDIF
-
-       CALL wrd_write_string( 'qc' )
-       WRITE ( 14 )  qc
-
-       IF ( ALLOCATED( qc_av ) )  THEN
-          CALL wrd_write_string( 'qc_av' )
-          WRITE ( 14 )  qc_av
-       ENDIF
-
-       IF ( microphysics_morrison )  THEN
-
-          CALL wrd_write_string( 'nc' )
-          WRITE ( 14 )  nc
-
-          IF ( ALLOCATED( nc_av ) )  THEN
-             CALL wrd_write_string( 'nc_av' )
-             WRITE ( 14 )  nc_av
-          ENDIF
-
-       ENDIF
-
-       IF ( microphysics_seifert )  THEN
-
-          CALL wrd_write_string( 'nr' )
-          WRITE ( 14 )  nr
-
-          IF ( ALLOCATED( nr_av ) )  THEN
-             CALL wrd_write_string( 'nr_av' )
-             WRITE ( 14 )  nr_av
-          ENDIF
-
-          CALL wrd_write_string( 'qr' )
-          WRITE ( 14 )  qr
-
-          IF ( ALLOCATED( qr_av ) )  THEN
-             CALL wrd_write_string( 'qr_av' )
-             WRITE ( 14 )  qr_av
-          ENDIF
-
-       ENDIF
-
 
     END SUBROUTINE bcm_wrd_local
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4494)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! check new restart_data_format parameters
+! 
+! 4493 2020-04-10 09:49:43Z pavelkrc
 ! Kolmogorov length scale eta added to profile output
 !
@@ -245,4 +248,37 @@
        CALL message( 'check_parameters', 'PA0476', 1, 2, 0, 6, 0 )
     ENDIF
+
+!
+!-- Check and set the restart data format variables
+    IF ( TRIM( restart_data_format ) /= 'fortran_binary'  .AND.                                    &
+         TRIM( restart_data_format ) /= 'mpi' )  THEN
+       message_string = 'illegal restart data format "' // TRIM( restart_data_format ) // '"'
+       CALL message( 'check_parameters', 'PA....', 1, 2, 0, 6, 0 )
+    ENDIF
+
+    IF ( TRIM( restart_data_format_input ) == 'undefined' )  THEN
+       restart_data_format_input = restart_data_format
+    ENDIF
+    IF ( TRIM( restart_data_format_output ) == 'undefined' )  THEN
+       restart_data_format_output = restart_data_format
+    ENDIF
+
+    IF ( TRIM( restart_data_format_input ) /= 'fortran_binary'  .AND.                              &
+         TRIM( restart_data_format_input ) /= 'mpi' )  THEN
+       message_string = 'illegal restart data input format "' //                                   &
+                        TRIM( restart_data_format_input ) // '"'
+       CALL message( 'check_parameters', 'PA....', 1, 2, 0, 6, 0 )
+    ENDIF
+    IF ( TRIM( restart_data_format_output ) /= 'fortran_binary'  .AND.                             &
+         TRIM( restart_data_format_output ) /= 'mpi' )  THEN
+       message_string = 'illegal restart data output format "' //                                  &
+                        TRIM( restart_data_format_output ) // '"'
+       CALL message( 'check_parameters', 'PA....', 1, 2, 0, 6, 0 )
+    ENDIF
+
+!
+!-- Set flag for including total domain boundaries in the restart data (MPI-IO) in case of
+!-- non-cyclic boundary conditions
+    include_total_domain_boundaries = .NOT. ( bc_lr_cyc  .AND.  bc_ns_cyc )
 
 !
Index: palm/trunk/SOURCE/dynamics_mod.f90
===================================================================
--- palm/trunk/SOURCE/dynamics_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/dynamics_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Bugfix for last commit.
 ! 
@@ -129,4 +132,7 @@
         ONLY : nesting_mode
 
+!    USE restart_data_mpi_io_mod,                                                                   &
+!        ONLY:
+
     USE surface_mod, &
         ONLY :  bc_h
@@ -264,5 +270,6 @@
 
     INTERFACE dynamics_rrd_global
-       MODULE PROCEDURE dynamics_rrd_global
+       MODULE PROCEDURE dynamics_rrd_global_ftn
+       MODULE PROCEDURE dynamics_rrd_global_mpi
     END INTERFACE dynamics_rrd_global
 
@@ -1817,7 +1824,7 @@
 ! Description:
 ! ------------
-!> Read module-specific global restart data.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE dynamics_rrd_global( found )
+!> Read module-specific global restart data (Fortran binary format).
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE dynamics_rrd_global_ftn( found )
 
 
@@ -1840,5 +1847,19 @@
 
 
- END SUBROUTINE dynamics_rrd_global
+ END SUBROUTINE dynamics_rrd_global_ftn
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE dynamics_rrd_global_mpi
+
+
+!    CALL rrd_mpi_io( 'global_parameter', global_parameter )
+    CONTINUE
+
+ END SUBROUTINE dynamics_rrd_global_mpi
 
 
Index: palm/trunk/SOURCE/gust_mod.f90
===================================================================
--- palm/trunk/SOURCE/gust_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/gust_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! CASE statement for dummy variable u2_av in gust_rrd_local changed to avoid 
 ! unintended interdependencies with user-defined variables 
@@ -61,8 +64,14 @@
  MODULE gust_mod
 
+    USE control_parameters,                                                                        &
+        ONLY:  restart_data_format_output
+
     USE indices,                                                               &
         ONLY:  nxl, nxlg, nxr, nxrg, nys, nysg, nyn, nyng, nzb, nzt
 
     USE kinds
+
+!    USE restart_data_mpi_io_mod,                                                                   &
+!        ONLY:
 
     IMPLICIT NONE
@@ -168,5 +177,6 @@
 
     INTERFACE gust_rrd_global
-       MODULE PROCEDURE gust_rrd_global
+       MODULE PROCEDURE gust_rrd_global_ftn
+       MODULE PROCEDURE gust_rrd_global_mpi
     END INTERFACE gust_rrd_global
 
@@ -559,7 +569,7 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data for the gust module.
-!------------------------------------------------------------------------------!
-    SUBROUTINE gust_rrd_global( found )
+!> Read module-specific global restart data (Fortran binary format).
+!------------------------------------------------------------------------------!
+    SUBROUTINE gust_rrd_global_ftn( found )
 
 
@@ -588,5 +598,19 @@
 
 
-    END SUBROUTINE gust_rrd_global
+    END SUBROUTINE gust_rrd_global_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!------------------------------------------------------------------------------!
+    SUBROUTINE gust_rrd_global_mpi
+
+
+!       CALL rrd_mpi_io( 'global_parameter', global_parameter )
+!             READ ( 13 )  global_parameter
+
+    END SUBROUTINE gust_rrd_global_mpi
 
 
@@ -675,13 +699,23 @@
        IMPLICIT NONE
 
-! needs preceeding allocation if array
-!       CALL wrd_write_string( 'global_parameter' )
-!       WRITE ( 14 )  global_parameter
-
-!       IF ( ALLOCATED( inflow_damping_factor ) )  THEN
-!          CALL wrd_write_string( 'inflow_damping_factor' )
-!          WRITE ( 14 )  inflow_damping_factor
-!       ENDIF
-
+
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+!          CALL wrd_write_string( 'global_parameter' )
+!          WRITE ( 14 )  global_parameter
+
+!          IF ( ALLOCATED( inflow_damping_factor ) )  THEN
+!             CALL wrd_write_string( 'inflow_damping_factor' )
+!             WRITE ( 14 )  inflow_damping_factor
+!          ENDIF
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+!          CALL wrd_mpi_io( 'global_parameter', global_parameter )
+!          IF ( ALLOCATED( inflow_damping_factor ) )  THEN
+!             CALL wrd_mpi_io_global_array( 'inflow_damping_factor', inflow_damping_factor )
+!          ENDIF
+
+       ENDIF
 
     END SUBROUTINE gust_wrd_global
@@ -699,5 +733,6 @@
 
 
-! needs preceeding allocation because sould be array
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
 !          IF ( ALLOCATED( u2_av ) )  THEN
 !             CALL wrd_write_string( 'u2_av' )
@@ -705,4 +740,9 @@
 !          ENDIF
 
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+!          IF ( ALLOCATED( u2_av ) )  CALL wrd_mpi_io( 'u2_av', u2_av )
+
+       ENDIF
 
     END SUBROUTINE gust_wrd_local
